/*
 * Copyright 2016 - 2023 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#pragma once

#include <ox/std/vector.hpp>

#include "typeconv.hpp"

namespace nostalgia::foundation {

class Module {
	public:
		constexpr Module() noexcept = default;
		Module(const Module&) noexcept = delete;
		Module(Module&&) noexcept = delete;
		Module &operator=(const Module&) noexcept = delete;
		Module &operator=(Module&&) noexcept = delete;
		constexpr virtual ~Module() noexcept = default;
		[[nodiscard]]
		virtual ox::Vector<foundation::BaseConverter*> converters() const noexcept;
		[[nodiscard]]
		virtual ox::Vector<PackTransform> packTransforms() const noexcept;
};

void registerModule(const Module *mod) noexcept;

[[nodiscard]]
const ox::Vector<const foundation::Module*> *modules() noexcept;

}
